--- title: "Insert New Row" url: https://docs.catalyst.zoho.com/en/api/code-reference/cloud-scale/data-store/insert-new-row/ description: "This API enables you to insert a new row of data or a record in a table in the Data Store." last_updated: 2026-08-17T12:16:04Z service: Cloud Scale type: api --- # Data Store [Catalyst Data Store](https://docs.catalyst.zoho.com/en/cloud-scale/help/data-store/introduction) is a cloud-based relational database management system which stores the persistent data of your application in the form of tables. Data Store APIs enable you to insert and manage records in the tables of your project's Data Store, obtain table and column details, and even perform bulk read and bulk write actions. However, you can create a table and its schema only from the Catalyst console. # Insert a New Row In a Table ### Description This API enables you to insert a new row of data or a record in a table in the Data Store, by referring to the table's unique ID or name. You must pass the column names and their corresponding values for the record in a JSON array in the request as described below. > **Note:** * The table and the columns in it must already be created. You can [create a table](https://docs.catalyst.zoho.com/en/cloud-scale/help/data-store/tables/#create-a-new-table) and the [columns](https://docs.catalyst.zoho.com/en/cloud-scale/help/data-store/columns/#create-a-new-column) for it from the console. * You will be able to insert upto 5000 records in each table per project in the [development environment](https://docs.catalyst.zoho.com/en/deployment-and-billing/environments/introduction/). You can create upto 25,000 records overall in each project in the development environment. There are no upper limits for record creation in the production environment. ### Request Details #### Request URL `POST` {api-domain}/baas/v1/project/{project_id}/table/{tableIdentifier}/row - **api-domain** (URL): The DC-specific domain to access Catalyst API - **project_id** (Numerical): The [unique ID](https://docs.catalyst.zoho.com/en/getting-started/set-up-a-catalyst-project/general-settings/) of the project - **tableIdentifier** (Numerical): The [unique ID](https://docs.catalyst.zoho.com/en/cloud-scale/help/data-store/tables/#create-a-new-table) of the table or table name #### Request Headers **Authorization:** Zoho-oauthtoken {oauth_token} **Content-Type:** application/json **Optional Headers** **CATALYST-ORG:** {org_id} **Environment:** Development #### Scope ZohoCatalyst.tables.rows.CREATE > **Note:** This operation can also be executed with Catalyst user authentication permissions using Catalyst SDKs. Refer to the [Catalyst API Prerequisites section](https://docs.catalyst.zoho.com/en/api/introduction/overview-and-prerequisites/#prerequisites) for details. #### Request JSON Array You must send the column names and their corresponding values in a **JSON array** like this: ```json { "column1_name": "column1_value", "column2_name": "column2_value", "column3_name": "column3_value", . . } ``` where `column_name` is the name of a unique column in the table, and `column_value` is its corresponding value in the record. > **Note:** You must send at least one column name and value pair to insert in the record. ### Response Details The response will contain the metadata of the row that was created such as its `ROWID` and `CREATEDTIME`, and the column key names and values that were inserted. **Sample Request** ```bash curl -X POST \ https://api.catalyst.zoho.com/baas/v1/project/4000000006007/table/EmpDetails/row \ -H "Authorization: Zoho-oauthtoken 1000.910*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*16.2f*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*57" \ -H "Content-Type:application/json" \ -d '[ { "Department_ID":"IT678", "Department_Name":"Marketing", "Employee_Name":"Robert Page" } ]' ``` **Sample Response** ```json { "status": "success", "data": [ { "CREATORID": "12096000000003003", "MODIFIEDTIME": "2023-06-05 11:35:14:332", "Department_ID": null, "Employee_Name": "Robert Page", "Department_Name": "Marketing", "CREATEDTIME": "2023-06-05 11:35:14:332", "ROWID": 12096000000642928 } ] } ``` ### SDK Documentation [Insert Rows- Java SDK](https://docs.catalyst.zoho.com/en/sdk/java/v1/cloud-scale/data-store/insert-rows) [Insert Rows- Node.js SDK](https://docs.catalyst.zoho.com/en/sdk/nodejs/v2/cloud-scale/data-store/insert-rows) [Insert Rows- Python SDK](https://docs.catalyst.zoho.com/en/sdk/python/v1/cloud-scale/data-store/insert-rows) [Insert Rows- Web SDK](https://docs.catalyst.zoho.com/en/sdk/web/v4/cloud-scale/data-store/insert-rows)